#Ejercicio3. IC Bootstrap para la media de una Exp(1). 
#n=100, B=1000, alpha=0.05

n<-100
B<-5000
M<-100
alpha<-0.05
tb<-numeric(B)
ICM<-matrix(0,nrow=M,ncol=2)

for(m in 1:M)
{ 
x<-rexp(n) #Non cońezo Exp!
media<-mean(x)#media muestral
desv<-sd(x) #cuasi-desviación típica

	for(b in 1:B)
	{
		xb<-sample(x,size=n,replace=T)
		mediab<-mean(xb)
		desvb<-sd(xb)
		tb[b]<-sqrt(n)*(mediab-media)/desvb
	}

stb<-sort(tb)
#Obtenemos los cuantiles Boostrap
clb<-stb[floor(alpha/2*B)]
cub<-stb[floor((1-alpha/2)*B)]
#hist(tb,freq=T)
#abline(v=clb,col=2,lwd=2)
#abline(v=cub,col=4,lwd=2)
a<-media-cub*desv/sqrt(n)
b<-media-clb*desv/sqrt(n)
ICM[m,]<-c(a,b)
}

coverage<-sum((ICM[,1]<=1)*(ICM[,2]>=1))


ind<-1:M
plot(ICM[,2]~ind,type="n",ylim=c(min(ICM[,1]),max(ICM[,2])))

for(i in 1:M){
	segments(ind[i],ICM[i,1],ind[i],ICM[i,2])
}
abline(h=1,col=3,lwd=2)
